﻿-- Visitor Radar
-- by Jadya
-- EU-Well of Eternity

local addonName, addonTable = ...
local L = addonTable.L -- localization
local addon = VisitorRadar
local version = 1000

local addontitle = "|cff00AAFFVisitor Radar|r"
local vricon = "Interface\\icons\\INV_Sigil_Freya"

local pName = GetUnitName("player")
local pRealm = GetRealmName()
addon.pID = pName.."-"..pRealm

function addon:GetCharacterData(character)
 local result = VisitorRadar_CharData[character]
 
 if result then
  local vid = result.visitor and result.visitor.id
  return result.t, vid
 end
end

function addon:SetCharacterData(character, t, vid)
 if not VisitorRadar_CharData[character] then VisitorRadar_CharData[character] = {} end

 local result = VisitorRadar_CharData[character]
 if not result.visitor then result.visitor = {} end
 result.t = t
 result.visitor.id = vid
 return result
end

-- npc detection
local updateFrame = CreateFrame("Frame")
local lastupdate = 0
local function update(self, elapsed)
 local zone = GetZoneText()
 if C_Garrison.IsUsingPartyGarrison() or (zone ~= GetMapNameByID(971) and zone ~= GetMapNameByID(976) and 
    zone ~= GARRISON_TOWN_HALL_HORDE and zone ~= GARRISON_TOWN_HALL_ALLIANCE) then
  return
 end

 local t = GetTime()
 if lastupdate < t - 0.1 then lastupdate = t else return end

 for k in pairs(addon.NPCs) do

  local function checkNPC(m)
   local guid = UnitGUID(m)
   
   if not guid then return end
   
   local _,_,_,_,_,_,_,id = string.find(guid, "(%a+)-(%d+)-(%d+)-(%d+)-(%d+)-(%d+)-(%d+)")
   id = tonumber(id)
   
   if id == k then
    addon:SetCharacterData(addon.pID, time() + GetQuestResetTime(), id)
	--updateFrame:Hide()
   end
  end

  checkNPC("mouseover")
  checkNPC("target")
 end
end
updateFrame:SetScript("OnUpdate", update)
updateFrame:Show()

addon.eventframe = CreateFrame("FRAME","VREventFrame")
addon.eventframe:RegisterEvent("VARIABLES_LOADED")
function addon.eventframe.VARIABLES_LOADED()
 if VisitorRadar_CharData == nil then VisitorRadar_CharData = {} end
 if VisitorRadar_Options == nil then VisitorRadar_Options = {} end
 local O = VisitorRadar_Options

 -- default options
 if O["show_in_guildframe"] == nil then O["show_in_guildframe"] = true end
 if O["noguild"] == nil then O["noguild"] = false end
 --

 O["Version"] = version
 
 addonTable:SetupConfigFrame()

 local outdated = {}

 local now = time()
 for k,v in pairs(VisitorRadar_CharData) do
  local t = v.t
  local vid = v.visitor and v.visitor.id
  if t and now > t then
   print(addontitle.." |cffFF0000debug|r - ("..k..") Visitor "..(L.ID2Name(vid) or "").." removed (outdated)")
   table.insert(outdated, k)
  end
 end
 
 for _,v in pairs(outdated) do
  VisitorRadar_CharData[v] = nil
 end
end

addon.eventframe:SetScript("OnEvent", function(self, event, ...) addon.eventframe[event](...) end)