-- Visitor Radar
-- by Jadya EU - Well of Eternity
-- communication
local addonName, addonTable = ...
local addon = VisitorRadar

-- message prefixes
local gvr_pref = "##GVRDATA##"
RegisterAddonMessagePrefix("##GVRDATA##")

local function sendmsg(s, chan, target)
 SendAddonMessage(gvr_pref, s, chan, target)
end

local function processmsg(s, ...)
 local input = {strsplit("@", s)}
 local character = select(2,...)

 -- this character doesn't want to show his visitor
 if input[1] == "hide" then
  VisitorRadar_CharData[character] = nil
  addonTable:ToggleButton(character, true)
  return
 elseif input[1] == "data" then
  if not VisitorRadar_CharData[character] then
   VisitorRadar_CharData[character] = {}
  end
 
  local ct = VisitorRadar_CharData[character]

  local _, vid = unpack(input)
  
  if vid then vid = tonumber(vid) end
  
  -- tell the guildroster frame that a character button needs to be shown
  addonTable:ToggleButton(character)
  
  -- we already have data
  if ct.visitor and ct.visitor.id == vid and ct.t > time() then return end
  
  ct.visitor = { ["id"] = vid }
  ct.t = time() + GetQuestResetTime()
 end
end

local lastpulse = 0
function addonTable:Pulse()
 local t = time()
 if lastpulse > t - 2 then return end
 
 -- invisible to guild
 local pref = "data"
 if VisitorRadar_Options and  VisitorRadar_Options["noguild"] then
  pref = "hide"
 end
 local _, vid = addon:GetCharacterData(addon.pID)
 if pref == "hide" or vid then
  local n = vid or ""
  -- additional data
  local add = ""
  --
  local output = pref.."@"..n.."@"..add
  sendmsg(output, "GUILD")
 end
 lastpulse = t
end

--[[
local updateFrame = CreateFrame("Frame")
local lastupdate = 0
local function update(self, elapsed)
 local t = GetTime()

 if lastupdate < t - 10 then lastupdate = t else return end
 
 --Pulse()
end
updateFrame:SetScript("OnUpdate", update)
updateFrame:Show()
]]

addon.eventframe:RegisterEvent("CHAT_MSG_ADDON")
function addon.eventframe.CHAT_MSG_ADDON(pref, ...)
 if pref == gvr_pref then
  processmsg(...)
 end
end